"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfViewer = void 0;
var react_1 = __importStar(require("react"));
var react_fast_compare_1 = __importDefault(require("react-fast-compare"));
var react_pdf_1 = require("react-pdf");
require("react-pdf/dist/esm/Page/AnnotationLayer.css");
require("../style/react_pdf_viewer.css");
var utils_1 = require("../utils");
var coordinates_1 = require("../utils/coordinates");
var PageLoader_1 = require("./PageLoader");
var PdfPage_1 = require("./PdfPage");
var PlaceholderPage_1 = require("./PlaceholderPage");
react_pdf_1.pdfjs.GlobalWorkerOptions.workerSrc = "//cdnjs.cloudflare.com/ajax/libs/pdf.js/" + react_pdf_1.pdfjs.version + "/pdf.worker.min.js";
var PdfViewer = /** @class */ (function (_super) {
    __extends(PdfViewer, _super);
    function PdfViewer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            textSelectionEnabled: true,
            numPages: 0,
        };
        /** Total left and right border width, needed as offset to avoid PageCanvas rendering past right page border. */
        _this.BORDER_WIDTH_OFFSET = 11;
        _this.TOP_WIDTH_OFFSET = 10;
        _this.containerDiv = null;
        _this.pageRefs = new Map();
        _this._mounted = false;
        /**
         * Lifecycle function
         */
        _this.componentDidMount = function () {
            _this._mounted = true;
            _this.computeSelectionMap();
            document.addEventListener("keydown", _this.onKeyDown);
            document.addEventListener("selectstart", _this.onTextSelectionStart);
            document.addEventListener("selectionchange", _this.onTextSelectionChange);
            document.addEventListener("scroll", _this.onScroll);
            // debug
            window.PdfViewer = _this;
        };
        _this.componentDidUpdate = function (prevProps) {
            if (_this.props.selections !== prevProps.selections)
                _this.computeSelectionMap();
            if (_this.props.url !== prevProps.url)
                _this.setState({ documentUuid: undefined });
            if (_this.props.scale !== prevProps.scale && _this.state.originalPageDimensions)
                _this.computeScaledPageDimensions(_this.state.originalPageDimensions);
        };
        _this.componentWillUnmount = function () {
            _this._mounted = false;
            document.removeEventListener("keydown", _this.onKeyDown);
            document.removeEventListener("selectstart", _this.onTextSelectionStart);
            document.removeEventListener("selectionchange", _this.onTextSelectionChange);
            document.removeEventListener("scroll", _this.onScroll);
        };
        _this.shouldComponentUpdate = function (nextProps, nextState) {
            return !react_fast_compare_1.default(_this.props, nextProps) || !react_fast_compare_1.default(_this.state, nextState);
        };
        /**
         * Helpers
         */
        _this.resetSelections = function () {
            _this.clearTextSelection();
            _this.clearAreaSelection();
        };
        _this.computeSelectionMap = function () {
            if (!_this.props.selections) {
                _this.selectionMap = undefined;
                return;
            }
            var selectionMap = new Map();
            _this.props.selections.forEach(function (selection) {
                var _a;
                selectionMap.set(selection.position.pageNumber, __spreadArrays(((_a = selectionMap.get(selection.position.pageNumber)) !== null && _a !== void 0 ? _a : []), [
                    selection,
                ]));
            });
            _this.selectionMap = selectionMap;
        };
        _this.computePageDimensions = function (pdf) {
            var promises = Array.from({ length: pdf.numPages })
                .map(function (x, i) { return i + 1; })
                .map(function (pageNumber) {
                return new Promise(function (resolve, reject) {
                    pdf.getPage(pageNumber).then(resolve, reject);
                });
            });
            Promise.all(promises).then(function (pages) {
                if (!_this._mounted)
                    return;
                var originalPageDimensions = new Map();
                for (var _i = 0, pages_1 = pages; _i < pages_1.length; _i++) {
                    var page = pages_1[_i];
                    var width = page.view[2];
                    var height = page.view[3];
                    originalPageDimensions.set(page.pageNumber, { width: width, height: height });
                }
                _this.computeScaledPageDimensions(originalPageDimensions);
                _this.setState({ originalPageDimensions: originalPageDimensions });
            });
        };
        _this.computeScaledPageDimensions = function (originalPageDimensions) {
            var _a, _b;
            var pageDimensions = new Map();
            var pageYOffsets = new Array(originalPageDimensions.size);
            pageYOffsets[0] = _this.TOP_WIDTH_OFFSET;
            originalPageDimensions.forEach(function (dimension, pageNumber) {
                var width = dimension.width * _this.props.scale;
                var height = dimension.height * _this.props.scale;
                pageDimensions.set(pageNumber, { width: width, height: height });
                if (pageNumber < originalPageDimensions.size)
                    pageYOffsets[pageNumber] = pageYOffsets[pageNumber - 1] + height + _this.BORDER_WIDTH_OFFSET;
            });
            var visiblePages = _this.getVisiblePages(document.documentElement, pageYOffsets);
            _this.setState({ pageDimensions: pageDimensions, pageYOffsets: pageYOffsets, visiblePages: visiblePages });
            (_b = (_a = _this.props).onPageDimensions) === null || _b === void 0 ? void 0 : _b.call(_a, { pageDimensions: pageDimensions, pageYOffsets: pageYOffsets });
        };
        _this.getVisiblePages = function (scrollElement, pageYOffsets) {
            var pageOffsets = pageYOffsets !== null && pageYOffsets !== void 0 ? pageYOffsets : _this.state.pageYOffsets;
            if (!pageOffsets)
                return [];
            var scrollTop = scrollElement.scrollTop, clientHeight = scrollElement.clientHeight;
            var firstVisiblePageIdx = pageOffsets.findIndex(function (offset) { return offset > scrollTop; });
            var lastVisiblePageIds = scrollTop + clientHeight > pageOffsets[pageOffsets.length - 1]
                ? pageOffsets.length - 1
                : pageOffsets.findIndex(function (offset) { return offset > scrollTop + clientHeight; });
            var underScanPages = Array.from({ length: Math.min(_this.props.overscanCount, firstVisiblePageIdx) }).map(function (_, i) { return firstVisiblePageIdx - i - 1; });
            var overScanPages = Array.from({
                length: Math.min(_this.props.overscanCount, _this.state.numPages - lastVisiblePageIds - 1),
            }).map(function (_, i) { return i + lastVisiblePageIds + 1; });
            var visibleCount = lastVisiblePageIds - firstVisiblePageIdx + 1;
            var visiblePages = Array.from({ length: visibleCount }).map(function (x, i) { return i + firstVisiblePageIdx; });
            return __spreadArrays(underScanPages, visiblePages, overScanPages);
        };
        _this.getItemKey = function (index) {
            return "doc_" + _this.state.documentUuid + "_page_" + index;
        };
        _this.getPageRef = function (pageNumber) {
            var ref = _this.pageRefs.get(pageNumber);
            if (!ref) {
                ref = react_1.createRef();
                _this.pageRefs.set(pageNumber, ref);
            }
            return ref;
        };
        /**
         * Text selection handlers
         */
        _this.clearTextSelection = function () {
            var _a, _b, _c;
            (_a = utils_1.getWindow(_this.containerDiv).getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges();
            (_c = (_b = _this.props).onTextSelection) === null || _c === void 0 ? void 0 : _c.call(_b);
        };
        _this.onTextSelectionStart = function () {
            _this.clearAreaSelection();
        };
        _this.onTextSelectionChange = function () {
            var _a, _b;
            var selection = utils_1.getWindow(_this.containerDiv).getSelection();
            if (!selection || selection.isCollapsed)
                return;
            var range = selection.rangeCount > 0 ? selection.getRangeAt(0) : undefined;
            if (!range)
                return;
            var page = utils_1.getPageFromRange(range);
            if (!page)
                return;
            var pageDimension = { width: page.node.clientWidth, height: page.node.clientHeight };
            var rects = utils_1.getClientRects(range, page.node);
            if (rects.length === 0)
                return;
            var boundingRect = utils_1.getBoundingRect(rects);
            var position = coordinates_1.normalizePosition({ boundingRect: boundingRect, rects: rects, pageNumber: page.number }, pageDimension);
            var text = Array.from(range.cloneContents().childNodes)
                .map(function (node) { return node.textContent; })
                .join(" ");
            (_b = (_a = _this.props).onTextSelection) === null || _b === void 0 ? void 0 : _b.call(_a, { position: position, text: text });
        };
        /**
         * Area selection handlers
         */
        _this.clearAreaSelection = function () {
            var _a, _b;
            _this.setState({ areaSelectionActivePage: undefined, textSelectionEnabled: true });
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a);
        };
        _this.onAreaSelectionStart = function (pageNumber) {
            _this.clearTextSelection();
            _this.setState({ textSelectionEnabled: false, areaSelectionActivePage: pageNumber });
        };
        _this.onAreaSelectionEnd = function (selection) {
            var _a, _b;
            _this.setState({ textSelectionEnabled: true });
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a, selection);
        };
        /**
         * Event handlers
         */
        _this.onKeyDown = function (event) {
            if (event.key === "Escape")
                _this.resetSelections();
        };
        _this.onMouseDown = function () {
            _this.resetSelections();
        };
        _this.onScroll = function (event) {
            var _a;
            if (!_this.containerDiv || !_this.state.pageYOffsets)
                return;
            var scrollElement = (_a = event.target) === null || _a === void 0 ? void 0 : _a.scrollingElement;
            if (!scrollElement)
                return;
            var visiblePages = _this.getVisiblePages(scrollElement);
            _this.setState({ visiblePages: visiblePages });
        };
        _this.onDocumentLoad = function (pdf) {
            _this.computePageDimensions(pdf);
            _this.setState({ numPages: pdf.numPages, documentUuid: utils_1.generateUuid() });
        };
        _this.renderPages = function () {
            return Array.from(new Array(_this.state.numPages), function (el, i) {
                var _a, _b, _c;
                var pageNumber = i + 1;
                if (!_this.state.visiblePages || !_this.state.visiblePages.includes(i))
                    return (react_1.default.createElement(PlaceholderPage_1.PlaceholderPage, { key: _this.getItemKey(i), pageDimensions: (_a = _this.state.pageDimensions) === null || _a === void 0 ? void 0 : _a.get(pageNumber) }));
                var props = {
                    style: {},
                    pageNumber: pageNumber,
                    innerRef: _this.getPageRef(pageNumber),
                    areaSelectionActive: _this.state.areaSelectionActivePage === pageNumber,
                    pageDimensions: (_b = _this.state.pageDimensions) === null || _b === void 0 ? void 0 : _b.get(pageNumber),
                    selections: (_c = _this.selectionMap) === null || _c === void 0 ? void 0 : _c.get(pageNumber),
                    enableAreaSelection: _this.props.enableAreaSelection,
                    onAreaSelectionStart: _this.onAreaSelectionStart,
                    onAreaSelectionEnd: _this.onAreaSelectionEnd,
                    areaSelectionComponent: _this.props.areaSelectionComponent,
                    textSelectionComponent: _this.props.textSelectionComponent,
                    newAreaSelectionComponent: _this.props.newAreaSelectionComponent,
                };
                return react_1.default.createElement(PdfPage_1.PdfPage, __assign({ key: _this.getItemKey(i) }, props));
            });
        };
        _this.render = function () {
            var _a, _b;
            var loading = (_a = _this.props.loading) !== null && _a !== void 0 ? _a : react_1.default.createElement(PageLoader_1.PageLoader, null);
            var document = (react_1.default.createElement("div", { ref: function (ref) { return (_this.containerDiv = ref); }, style: {
                    position: "relative",
                }, onContextMenu: function (e) { return e.preventDefault(); }, onPointerDown: _this.onMouseDown },
                react_1.default.createElement("style", null, "\n                        .react-pdf__Page__textContent span::selection {\n                            background-color: " + ((_b = _this.props.textSelectionColor) !== null && _b !== void 0 ? _b : "blue") + ";\n                    "),
                react_1.default.createElement(react_pdf_1.Document, { className: _this.state.textSelectionEnabled ? "" : "no-select", file: _this.props.url, loading: loading, onLoadSuccess: _this.onDocumentLoad }, _this.containerDiv && _this.state.documentUuid && _this.state.pageDimensions && _this.renderPages())));
            return _this.props.children ? _this.props.children({ document: document }) : document;
        };
        return _this;
    }
    PdfViewer.defaultProps = {
        overscanCount: 1,
        scale: 1.2,
    };
    return PdfViewer;
}(react_1.Component));
exports.PdfViewer = PdfViewer;
